// ignore_for_file: public_member_api_docs

import 'package:copy_with_extension/copy_with_extension.dart';
import 'package:fl_chart/fl_chart.dart';
import 'package:flutter/material.dart';
import 'package:healthrian_visualization_support/'
    'healthrian_visualization_support.dart';

part 'stream_single_channel.g.dart';

@CopyWith()
class StreamSingleChannel extends StatelessWidget {
  const StreamSingleChannel({
    super.key,
    required this.stream,
    this.onLoadingWidget,
    required this.measureTime,
    required this.isFiltered,
    required this.strokeWidth,
    required this.samplingRate,
    required this.isVisibleGrid,
    required this.maxY,
    required this.minY,
    required this.color,
  });

  final Stream<List<FlSpot>> stream;
  final Widget? onLoadingWidget;

  final int measureTime;
  final bool isFiltered;
  final double strokeWidth;
  final int samplingRate;
  final bool isVisibleGrid;

  final double maxY;
  final double minY;

  final Color color;

  @override
  Widget build(BuildContext context) {
    return StreamBuilder(
      stream: stream,
      builder: (context, snapshot) {
        if (!snapshot.hasData) onLoadingWidget ?? const SizedBox();
        return Channel(
          ecgSequence: snapshot.data!,
          measureTime: measureTime,
          isFiltered: isFiltered,
          strokeWidth: strokeWidth,
          samplingRate: samplingRate,
          isVisibleGrid: isVisibleGrid,
          maxY: maxY,
          minY: minY,
          color: color,
        );
      },
    );
  }
}
